//Open "back" in new tab
function TabGoBack(event)
{
if(event.button==1 && event.target.id == 'back-button' || event.ctrlKey == true && event.target.id == 'back-button')
	{
	var instance = Components.classes['@mozilla.org/browser/shistory-internal;1'].createInstance(Components.interfaces.nsIWebNavigation);
	instance = instance.QueryInterface(Components.interfaces.nsIWebNavigation);
	if(gBrowser.canGoBack) var newTab = DoSHStuff(-1);
	event = event.stopPropagation(event);
	try{ gBrowser.moveTabTo(newTab, Number(gBrowser.selectedTab.ordinal)); } catch(e) {};
	return;
	}
else if(event.shiftKey == true && event.target.id == 'back-button')
	{
	event = event.stopPropagation(event);
	if(gBrowser.canGoBack) SHWindow(-1, "not");
	return;
	}
else return;
}


//Open "forward" in new tab
function TabGoForward(event)
{
if(event.button==1 && event.target.id == 'forward-button' || event.ctrlKey == true && event.target.id == 'forward-button')
	{
	var instance = Components.classes['@mozilla.org/browser/shistory-internal;1'].createInstance(Components.interfaces.nsIWebNavigation);
	instance = instance.QueryInterface(Components.interfaces.nsIWebNavigation);
	if(gBrowser.canGoForward) var newTab = DoSHStuff(1);
	event = event.stopPropagation(event);
	try{ gBrowser.moveTabTo(newTab, Number(gBrowser.selectedTab.ordinal) + 1); } catch(e) {};
	return;
	}
else if(event.shiftKey == true && event.target.id == 'forward-button')
	{
	event = event.stopPropagation(event);
	if(gBrowser.canGoForward) SHWindow(1, "not");
	return;
	}
}


//Open "home" in new tab
function TabGoHome(event)
{
if(event.shiftKey == true)
	{
	var r = window.openDialog("chrome://browser/content/", "_blank", "chrome, all, dialog=no");
	r.setTimeout(function() {r.BrowserHome();}, 1000);
	r.clearTimeout();
	event=event.stopPropagation();
	return;
	}
else if(gURLBar.value != null && gURLBar.value != "" && gURLBar.value != "about:blank")
	{
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var homePage = gPrefService.getComplexValue("browser.startup.homepage", Components.interfaces.nsIPrefLocalizedString).data;
	var newTab = gBrowser.addTab(homePage);
        if (!pref.getBoolPref("browser.tabs.loadInBackground")) getBrowser().selectedTab = newTab;
	event=event.stopPropagation();
	return;
	}
else BrowserHome();
}

//Stop for all tabs
function StopAllTabs(event)
{
if(event.button == 1 && event.target.id == "stop-button" || event.ctrlKey == 'true' && event.target.id == "stop-button");
	{
		for(i = 0; gBrowser.mCurrentTab.parentNode.childNodes[i] ; i++)
		{
		if(gBrowser.mCurrentTab.parentNode.childNodes[i]) gBrowser.getBrowserForTab(gBrowser.mCurrentTab.parentNode.childNodes[i]).stop();
		else return;
		}
	}
event=event.stopPropagation();
return;
}

//Open "reload" in new tab or window
function TabGoReload(event)
{
if(gURLBar.value != null && gURLBar.value != "" && gURLBar.value != "about:blank" && event.ctrlKey == true && event.button == 1)
	{
	event.preventDefault();	
	SHWindow(0, "not");
	}
else if(gURLBar.value != null && gURLBar.value != "" && gURLBar.value != "about:blank")
	{
	var newTab = DoSHStuff(0);
	var newbrowser = getBrowser().getBrowserForTab(newTab);
	newbrowser.sessionHistory.updateIndex();
	if(event.shiftKey) var reloadFlags = nsIWebNavigation.LOAD_FLAGS_NONE;
	else var reloadFlags = nsIWebNavigation.LOAD_FLAGS_BYPASS_PROXY | nsIWebNavigation.LOAD_FLAGS_BYPASS_CACHE;
	newbrowser.reload(reloadFlags);
	}
else return;
}


//Open "throbber" in new tab
function TabGoThrobber(event)
{
if(event.shiftKey == true)
	{
	var r = window.openDialog("chrome://browser/content/", "_blank", "chrome, all, dialog=no");
	r.setTimeout(function() {goClickThrobber('browser.throbber.url');}, 1000);
	r.clearTimeout();
	}
else if(gURLBar.value != null && gURLBar.value != "" && gURLBar.value != "about:blank")
	{
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var throbberUrl = gPrefService.getComplexValue("browser.throbber.url", Components.interfaces.nsIPrefLocalizedString).data;
	var newTab = gBrowser.addTab(throbberUrl);
        if (!pref.getBoolPref("browser.tabs.loadInBackground")) getBrowser().selectedTab = newTab;
	}
else goClickThrobber('browser.throbber.url');
}

//Open "go" in new tab
function TabGoGo(event)
{
if(gURLBar.value != null && gURLBar.value != "" && gURLBar.value != "about:blank")
	{
	if(event.button==1 || event.ctrlKey == true)
		{
		var URL = gURLBar.value;
		var newTab = DoSHStuff(0, 'go');
		var newbrowser = getBrowser().getBrowserForTab(newTab);
		var instance = Components.classes['@mozilla.org/browser/session-history-entry;1'].createInstance(Components.interfaces.nsISHEntry);
		instance = instance.QueryInterface(Components.interfaces.nsIHistoryEntry);
		var SH = gBrowser.sessionHistory;
		var newestEntry = SH.getEntryAtIndex(SH.count - 1, false).URI.spec;
		if(newestEntry != URL) newbrowser.loadURI(URL);
		event = event.stopPropagation(event);
		}
	else if(event.shiftKey == true)
		{
		var URL = gURLBar.value;
		var instance = Components.classes['@mozilla.org/browser/session-history-entry;1'].createInstance(Components.interfaces.nsISHEntry);
		instance = instance.QueryInterface(Components.interfaces.nsIHistoryEntry);
		var SH = gBrowser.sessionHistory;
		var newestEntry = SH.getEntryAtIndex(SH.count - 1, false).URI.spec;
		var newWindow = SHWindow(0, 'go');
		if(newestEntry != URL)
			{
			var timer = newWindow.setTimeout(function() { newWindow.document.getElementById("content").loadURI(URL); }, 1000);
			}
		event = event.stopPropagation(event);
		}
	}
}


//Copy session history function for Back and Forward functions
function DoSHStuff(ref, type)
{
var COUNTER = null;
var instance = Components.classes['@mozilla.org/browser/session-history-entry;1'].createInstance(Components.interfaces.nsISHEntry);
instance = instance.QueryInterface(Components.interfaces.nsIHistoryEntry);
var SH = gBrowser.sessionHistory;
if(SH.count == 0) return getBrowser().selectedTab;
if(type == 'menu') var URL = ref;
else var URL = SH.index.valueOf() + ref;
if(type == 'go') COUNTER = SH.index.valueOf() + 1;

	var entries = [],
	entry,
	x       = {},
	y       = {},
	content;
	if (SH)
	for (i = 0; i < SH.count; i++)
	{
		entry = SH.getEntryAtIndex(i, false);
		if (entry)
		entries.push(entry);
	}

var newTab = gBrowser.addTab("about:blank"); 
var newbrowser = getBrowser().getBrowserForTab(newTab);
var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
if (!pref.getBoolPref("browser.tabs.loadInBackground")) getBrowser().selectedTab = newTab;

Components.classes['@mozilla.org/browser/shistory;1'].createInstance(Components.interfaces.nsISHistoryInternal);
var SHInternal = newbrowser.sessionHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);
if(COUNTER == null) COUNTER = i;

	for (q = 0; q < COUNTER; q++)
	{
		restore = entries[q];
		if (entry) SHInternal.addEntry(entries[q],true);
	}

SHInternal.updateIndex();
newbrowser.gotoIndex(URL, false);
return newTab;
}


//copy session history into new window
function SHWindow(BF, type)
{
var COUNTER = null;
var instance = Components.classes['@mozilla.org/browser/session-history-entry;1'].createInstance(Components.interfaces.nsISHEntry);
instance = instance.QueryInterface(Components.interfaces.nsIHistoryEntry);
var SH = gBrowser.sessionHistory;
var URL = SH.index.valueOf();
if(type == 'go') COUNTER = SH.index.valueOf() + 1;

	var entries = [],
	entry,
	x       = {},
	y       = {},
	content;
	if (SH)
	for (i = 0; i < SH.count; i++)
	{
		entry = SH.getEntryAtIndex(i, false);
		if (entry)
		entries.push(entry);
	}

var w = window.openDialog("chrome://browser/content/", "_blank", "chrome, all, dialog=no");
var timer = w.setTimeout(function() { domore(BF, type); }, 1000);
function domore(BF, type)
	{
   
   var SHInternal = Components.classes['@mozilla.org/browser/shistory;1'].createInstance(Components.interfaces.nsISHistoryInternal);
   SHInternal = w.gBrowser.sessionHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);
   w.clearTimeout(timer);
   if(COUNTER == null) COUNTER = i;
	for (q = 0; q < COUNTER; q++)
	{
		restore = entries[q];
		if (entry) SHInternal.addEntry(entries[q],true);
	}


   SHInternal.updateIndex();
   if(type == "specific")
	{
	URL = BF;
	w.gBrowser.gotoIndex(URL);
	w.focus();
	}
   else
	{
	URL = URL + BF;
   	if(SHInternal.count != 0) w.gBrowser.gotoIndex(URL);
   	w.focus();
	}	
	}
return w;
}

function BackFor(event, BF)
{
if(event.shiftKey == true)
	{
	var index = event.target.getAttribute('index');
	SHWindow(index, "specific");
	event.preventBubble();
	event.stopPropagation();
	event.preventDefault();
	return;
	}
else if(event.button == 1 || event.ctrlKey == true)
	{
	var index = event.target.getAttribute('index');
	var newTab = DoSHStuff(index, 'menu');
	var newbrowser = getBrowser().getBrowserForTab(newTab);
	if(BF == 'B') 
		{
		try { gBrowser.moveTabTo(newTab, Number(gBrowser.selectedTab.ordinal));}  
		catch(e) {} 
		}
	else if(BF == 'F') 
		{
		try { gBrowser.moveTabTo(newTab, Number(gBrowser.selectedTab.ordinal) + 1);}  
		catch(e) {} 
		}
	event.stopPropagation();
	}
}

function OnMulti(event, type)
{
if(lmouse == 'down' && rmouse == 'down')
	{
	rmouse = "up";
	lmouse = "up";
	event.stopPropagation(event);
	event.preventDefault(event);
	event.preventBubble(event);
	
	if(type == 'back') 
		{
		var instance = Components.classes['@mozilla.org/browser/session-history-entry;1'].createInstance(Components.interfaces.nsISHEntry);
		instance = instance.QueryInterface(Components.interfaces.nsIHistoryEntry);
		var SH = gBrowser.sessionHistory;
		if(SH) gBrowser.gotoIndex(0);
		return;
		}	
	if(type == 'forward')
		{
		var instance = Components.classes['@mozilla.org/browser/session-history-entry;1'].createInstance(Components.interfaces.nsISHEntry);
		instance = instance.QueryInterface(Components.interfaces.nsIHistoryEntry);
		var SH = gBrowser.sessionHistory;
		if(SH) gBrowser.gotoIndex(SH.count-1);
		return;
		}
	if(type == 'reload')
		{
		event.preventDefault();	
		SHWindow(0, "not");
		return;
		}
	else
		{
		alert("MozFBRH - There is currently no MultiClick Function associated with this button.");
		return;
		}
	}
multiEx = "no";
}


//tests to see if digger's overlay exists. If it does, modifies it to not conflict with MozFBRH
function DiggerTestFix()
{
try { var GB = document.getElementById("go-button"); }
catch(e) {};
if(GB.getAttribute('onclick') == "if(event.button==1) diggerLoadURLInNewTab(event);")
	{
	GB.setAttribute('onclick', "if(event.button == 1 || event.ctrlKey == true || event.shiftKey == true) TabGoGo(event);")
	}
else return;
}

//function to determine if customize menu should be shown or not, and prevent it if it should not
function makeitstop(event)
{
if(lmouse == 'down' || multiEx == 'yes') event = event.preventDefault();
else return;
}


//initializer, called when browser is opened to add event listeners for some buttons
function initThing()
{
document.getElementById('back-button').addEventListener('click', TabGoBack, true);
document.getElementById('forward-button').addEventListener('click', TabGoForward, true);

//multiclick event listeners for back and forward
document.getElementById("back-button").addEventListener('mousedown', function(event){OnMulti(event, 'back');}, true);
document.getElementById("forward-button").addEventListener('mousedown', function(event){OnMulti(event, 'forward');}, true);

//event listeners for back and forward dropdowns, which send click AND command events, so I need to listen for both
document.getElementById("back-button").firstChild.addEventListener('command', function(event) {BackFor(event, "B");}, true);
document.getElementById("back-button").firstChild.addEventListener('click', function(event) {if(event.button == 1) BackFor(event, "B"); else if(event.shiftKey == true || event.ctrlKey == true) event.stopPropagation(event);}, true);
document.getElementById("forward-button").firstChild.addEventListener('command', function(event) {BackFor(event, "F");}, true);
document.getElementById("forward-button").firstChild.addEventListener('click', function(event) {if(event.button == 1) BackFor(event, "F"); else if(event.shiftKey == true || event.ctrlKey == true) event.stopPropagation(event);}, true);

//event listeners for back and forward context menu dropdowns
document.getElementById("backMenu").addEventListener('command', function(event) {BackFor(event, "B");}, true);
document.getElementById("backMenu").addEventListener('click', function(event) {if(event.button == 1) BackFor(event, "B"); else if(event.shiftKey == true || event.ctrlKey == true) event.stopPropagation(event);}, true);
document.getElementById("forwardMenu").addEventListener('command', function(event) {BackFor(event, "F");}, true);
document.getElementById("forwardMenu").addEventListener('click', function(event) {if(event.button == 1) BackFor(event, "F"); else if(event.shiftKey == true || event.ctrlKey == true) event.stopPropagation(event);}, true);

//NEW event listeners for multiclicks
document.getElementById('navigator-toolbox').addEventListener('mousedown', function(event) {if(event.button == 0) lmouse = "down"; window.setTimeout(function() { lmouse = "up"; }, 1000); }, true);
document.getElementById('navigator-toolbox').addEventListener('mousedown', function(event) {if(event.button == 2) rmouse = "down"; window.setTimeout(function() { lmouse = "up"; }, 1000); }, true);
document.getElementById('navigator-toolbox').addEventListener('mouseup', function(event) {if(event.button == 0) lmouse = "up";}, true);
document.getElementById('navigator-toolbox').addEventListener('mouseup', function(event) {if(event.button == 2) rmouse = "up";}, true);
document.getElementById('navigator-toolbox').addEventListener("popuphidden",function(event){ rmouse = 'up';}, true);

//Event listener for customize menu
document.getElementById('toolbar-context-menu').addEventListener('popupshowing', function(event) {makeitstop(event)}, true);

//Test for Digger and fix if necessary
DiggerTestFix();
}

//variables for multiclicks
var rmouse = "up";
var lmouse = "up";
var multiEx = "no";
//this line makes everything work, don't touch it.
window.addEventListener("load", initThing, false);
window.addEventListener("load", function() {window.tablib.init();}, false);
window.addEventListener("load", function() {setTimeout(toggleAutoFillInURLBar, 0);} , false);

function toggleAutoFillInURLBar()
{
    var gPrefService = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefService);
    gPrefService = gPrefService.getBranch(null);
    var domain = "browser.urlbar.autoFill";
    var prefValue = gPrefService.getBoolPref(domain);
    if (prefValue)
      gURLBar.setAttribute("completedefaultindex", "true");
    else
      gURLBar.removeAttribute("completedefaultindex");
}

function MozFBRHhandleURLBarCommand(aTriggeringEvent)
{
  canonizeUrl(aTriggeringEvent);

  try { 
    addToUrlbarHistory();
  } catch (ex) {
    // Things may go wrong when adding url to session history,
    // but don't let that interfere with the loading of the url.
  }

 if (gBrowser.localName == "tabbrowser" &&
        aTriggeringEvent && 'altKey' in aTriggeringEvent &&
        aTriggeringEvent.altKey) 
	{
	var URL = gURLBar.value;
	var instance = Components.classes['@mozilla.org/browser/session-history-entry;1'].createInstance(Components.interfaces.nsISHEntry);
	instance = instance.QueryInterface(Components.interfaces.nsIHistoryEntry);
	var SH = gBrowser.sessionHistory;
	var newestEntry = SH.getEntryAtIndex(SH.count - 1, false).URI.spec;
	var newTab = DoSHStuff(0, 'go');
	var newbrowser = getBrowser().getBrowserForTab(newTab);
	if(newestEntry != URL) newbrowser.loadURI(URL);
	getBrowser().selectedTab = newTab;
	}
  else BrowserLoadURL(aTriggeringEvent); 
}

